;
;   Random BMP Put Mini Sample by Pavlushin Evgeni for ASCL
;   www.waptap@mail.ru
;


;******************************************************************************
    use32
    org    0x0
    db     'MENUET01'              ; 8 byte id
    dd     0x01                    ; header version
    dd     START                   ; start of code
    dd     IM_END                  ; size of image
    dd     0x300000                ; memory for app
    dd     0x300000                ; esp
    dd     temp_area , 0x0         ; I_Param , I_Icon

;******************************************************************************
;5941 ;4523(with new random)



include 'ascl.inc'
include 'ascgl.inc'

START:                          ; start of execution
    call draw_window

    loadfile '/RD/1/MFAR.BMP',I_END,temp_area
    bmptoimg I_END,img
    loadfile '/RD/1/SMILE.BMP',I_END,temp_area
    bmptoimg I_END,img2
    loadfile '/RD/1/COPY.BMP',I_END,temp_area
    bmptoimg I_END,img3

    fullimg img4 , 32 ,32 ,0x00000000   ;black

still:



    mov  eax,11                 ; scan event
    int  0x40

    cmp  eax,1                  ; redraw request ?
    je   red
    cmp  eax,2                  ; key in buffer ?
    je   key
    cmp  eax,3                  ; button in buffer ?
    je   button

del_images:


    setimg dword [ply2x],dword [ply2y],img4
    setimg dword [ballx],dword [bally],img4



move_images:

x_move:
    mov eax,dword [ply1rx]
    cmp dword [ply1x],eax
    je  no_m
    cmp dword [ply1x],eax
    jg  m_m
m_p:
    add dword [ply1x],2
    jmp no_m
m_m:
    sub dword [ply1x],2
no_m:


y_move:
    mov eax,dword [ply1ry]
    cmp dword [ply1y],eax
    je  no_m2
    cmp dword [ply1y],eax
    jg  m_m2
m_p2:
    add dword [ply1y],2
    jmp no_m2
m_m2:
    sub dword [ply1y],2
no_m2:



redraw_images:
;    setimg dword [ply1x],dword [ply1y],img
    setimg dword [ply2x],dword [ply2y],img2 ;2
    setimg dword [ballx],dword [bally],img3

    push dword [ply1y]
    push dword [ply1x]
    mov eax,0
    mov ebx,0
    mov ecx,0
xloop:
    cmp dword [ply1x],640+6
    ja no_norm
    cmp dword [ply1y],480+24
    ja no_norm
    mov dl,byte [matrix+ecx]
    cmp dl,' '
    jne no_b
    mov ebp,img2
    jmp norm
no_b:
    mov ebp,img
norm:
    pushad
    setimg dword [ply1x],dword [ply1y],ebp
    popad
no_norm:
    inc ecx
    add dword [ply1x],32
    inc eax
    cmp eax,40
    jne xloop
    pop dword [ply1x]
    push dword [ply1x]
    mov eax,0
    inc ebx
    add dword [ply1y],32
    cmp ebx,14
    jne xloop
outofscr:
    pop dword [ply1x]
    pop dword [ply1y]


    delay 2             ;don't generate delay for fast speed programm

    jmp  still

  red:
    call draw_window
    jmp  still

  key:                          ; key
    mov eax,2
    int 0x40
    cmp ah,key_Left
    jne no_l
    sub dword [ply1rx],16
no_l:
    cmp ah,key_Right
    jne no_r
    add dword [ply1rx],16
no_r:
    cmp ah,key_Up
    jne no_u
    sub dword [ply1ry],16
no_u:
    cmp ah,key_Down
    jne no_d
    add dword [ply1ry],16
no_d:

    jmp  still

  button:                       ; button
    mov  eax,17                 ; get id
    int  0x40
    cmp  ah,1                   ; button id=1 ?
    jne  noclose
    mov  eax,-1                 ; close this program
    int  0x40
  noclose:
    jmp  still


draw_window:
    startwd
    window 0,0,640+8,480+24,window_Skinned
    label 12,8,'2D EXAMPLE: MOVE ICON: USE ARROW KEYS',cl_White+font_Big
;    call load_image
    endwd
    ret


; DATA AREA
xt dd 100
yt dd 100

ply1rx dd 200
ply1ry dd 50


ply1x dd 200
ply1y dd 50

ply2x dd 200
ply2y dd 400

ballx dd 200
bally dd 200

counter dd 0
tsoi dd 0
tsoi2 dd 0
tsoi3 dd 0

IM_END:

matrix:
    db '0123456789012345678901234567890123456789'
    db '0121      012345678901234567890123456789'
    db '0123456789012345678901234567890123456789'
    db '0123456789012345678901234567890123456789'
    db '0123456789012345678901234567890123456789'
    db '0121      012345678901234567890123456789'
    db '0123456789012345678901234567890123456789'
    db '0123456789012345678901234567890123456789'
    db '0123456789012345678901234567890123456789'
    db '0121      01234567890123456       456789'
    db '0123456789012345678901234567890123456789'
    db '01234567890123456789012       0123456789'
    db '012345678901234567890      7890123456789'
    db '0121      012345678901234567890123456789'

img:
rd 32*32*3+8
img2:
rb 32*32*3+8
img3:
rb 32*32*3+8
img4:
rb 32*32*3+8
img5:
rb 32*32*3+8


temp_area:
rb 0x15000

I_END:
